MODULE shared_var
!This module includes all the global variables
IMPLICIT NONE
SAVE

REAL, DIMENSION(100000) :: zpr, xQpr, gpr, Upr, zdtran, ldtran, xFpr, xMpr, g_e, Q_s, F_s
REAL, DIMENSION(100002) :: z,U, xM, xQ, gprimea, xfirst, xF,xQvent,xtime, b_array
REAL, DIMENSION(1) :: Prtime
REAL, DIMENSION(1) :: Ast ! 14

!INTEGER :: iPrmax
REAL :: iPrmax, dzetalim, dzetalim0, alpha, astarh, s, astar, deltat
REAL :: xfprime, v0, xxQ0, xL, deltaZ, time
REAL :: starHL, xF0, xM0, xQ0, gprime0, qmLs, c, g,gprimea_new
REAL :: rho_s, rho_inf, p0, rho_t, rho_b, delta_h
REAL :: H, xintgz, Umax, UU, z0, gap,p_e,p_s,Ast_non_dim,tau 

INTEGER :: iAst, umax_nogo, n_e, pd_layers
INTEGER :: j, imm, jx, i, iPrcount, iii, iyy !counters
INTEGER :: jj, jij, N, iAstmax, ii, ixd, mni, mmi, ijk 				  !counters
INTEGER :: test, valg, iError
INTEGER :: jHcount, jCross, ndtran 
INTEGER :: ilk, jdtran ! counters for the de-entrainment
INTEGER :: typestar ! printout counter
INTEGER :: stratified_on, deentrain_pos, gaussian_on 
INTEGER	::	has_deentrained, varying_buoyancy, avg_on

CONTAINS
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
SUBROUTINE init_var()
!This subroutine initializes the variables
 z = 0 		! height
 z0 = 0 	! virtual origin
 zpr = 0 	! z'
 zdtran = 0 !
 ldtran = 0 !
 U = 0		!
 Upr = 0	!
 gpr = 0	!
 gprimea = 0 ! g' ambient
 iPrcount = 0 ! print counter
 iAst=0    	! start iAst at 0 to get all the values in Ast(i)                  
 xfirst = 0	!
 xtime = 0	!
 xQ = 0		!
 xQvent = 0 !vent flow per unit length of source 
 xF = 0		!
 xM = 0		!
 b_array = 0.
 Q_s = 0.
 F_s = 0.
 gprimea(1) = 0 !initial g' in box

 !xQ, xQvent, xF and xM are all per unit horiz length of source 
 xQ0 = 0.0 ! Source volume, momentum and buoyancy flux are all zero
 xM0 = 0.0 ! at the leading edge of the distributed source.
 xF0 = 0.0 !
 

END SUBROUTINE init_var
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
SUBROUTINE start_values
!This subroutine gives the starting values and specifies
!timestep, A*, and at what time to write results.

! Prtime is an array containing the times at which we are 
! going to print out data
Prtime = (/4000./)
!Prtime = (/.1,.2,.5,1.1,4.,7.5,11.8,20.6,30.,40.8/)
iPrmax = SIZE(Prtime) ! The number of times the simulation will print
 
!Ast is an array containing values of A* at which we want to     
! carry out the simulation. Note that Ast_non_dim is the non dimensionalised
! value of A*

Ast = 0.00004944

!Ast = (/.0468, 0.0939, 1.2/)     
iAstmax= SIZE(Ast) !The number of A* values to simulate

dzetalim0 = 0.003! dzetalim is the max non-dimensional distance                     
                 ! an interface can move between time steps
stratified_on = 1 ! if = 1, the inital ambient is stratified, 

gaussian_on = 0 ! if = 1, the detrainment routine will use 
				! a gaussian profile for the intrusion

varying_buoyancy = 1 ! if = 1, the buoyancy is varying with height

!Source flow conditions:
!READ(11,*)qmLs,xL,H,S,gprime0,Astar,N
!@@ read from file OR use data below:
 !qmLs=1.e6   !qmLs - flow in [mL/s],
 xL=0.15 !1.       !source horiz Length [m]
 H= 0.412 !1.        !height of box
 S= 0.0618 !1.        ![m^2] = Horiz cross sectional area of box
 !gprime0 = 1. !3.231E-01  ! g' in [m^4s^-3],
 !gprime0 = 0.380103124  ! g' in [m^4s^-3], !0.380103124
 !gprime0 = 0.1
 !Dimensionlise dzetalim
dzetalim = dzetalim0 * H

 !LINEARLY STRATIFIED EXPERIMENT: RUN 10

 rho_s = 1037.5 ! source density [kg/m3]
 rho_inf = 998.8 ! ambient reference density [kg/m3]
 rho_t = 998.8
 rho_b = 998.8
 delta_h = 0.018

 gprime0=9.81*(rho_s-rho_inf)/rho_inf
 
 !p0 = 190.5 ! pressure difference at z = 0
 p0 = rho_s * 9.81 * delta_h
 
 
 ! flow coefficient of membrane
 ! c = 1./8.82e5
  c = 1./3.28e5 * (3.21/4.15)
   !c = 6e-7
 !c = 4.e-7
 !c = 1.2e-6 ! Eggebrecht
 !c = 1.0e-8
 g = 9.81

 xxQ0 = 3.206e-5 !	!total source vol. flow in m^3/s 

 xFprime = xxQ0 * gprime0/(xL*H)
 !xFprime = 3.5e-5 
 !xxQ0 = 8.
 

 z0=0.0                                     
 alpha= 0.02 !1.0 ! entrainment coefficient


END SUBROUTINE start_values
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$  


SUBROUTINE i_loop()
  DO
      ! i = 1 at first run
	  	deltaZ = z(i+1)-z(i)

      IF (varying_buoyancy == 1) THEN
         xFprime = F_s(i)
      ELSE
        ! (For plotting reasons:)
         F_s(i) = xFprime
      END IF
      
      CALL euler (z0, xQ(i), xM(i), deltaZ, xQ(i+1),xM(i+1),alpha, xF(i), xFprime)

      IF (i >= (jx)) EXIT ! exit i-loop if we have done all layers
	                        
!     Calc new new buoyancy flux of plume starting in next layer w.r.t. g' of that layer
      
         xF(i+1) = xF(i) + xFprime * deltaZ - xQ(i+1)*(gprimea(i+1)-gprimea(i))   !original!
      
      b_array(i) = 0.1*(4/3)* alpha * z(i) ! array containing the width of the plume NEEDS FIXING!

    ! SHOULD NOT ONLY BE NEGATIVELY BOUYANT, BUT ALSO HAVE ZERO VELOCITY

!	  IF (j <= 10) THEN !To early for detrainment!
!		i = i + 1      
!		CYCLE
!	  END IF

      
	  ! Check though the layers if any have the possibility of detraining
      IF (xF(i+1) >= 0.) THEN ! if not negative buoyancy: CYCLE      
        i = i + 1
        CYCLE
      END IF

 	IF (j > 0) THEN 
	GO TO 1212
	END IF
      
	WRITE(*,*) ' n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)'
	DO n_e = 1, jx+1
	WRITE(*,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
	END DO
	WRITE(*,*) ' there is a layer detraining for i=',i
	  WRITE(*,*) ' jx=',jx, ' time=',time,'i=',i
	PAUSE

 1212	CONTINUE

      ! *******************************************************************
	  ! xF(i+1) HAS NEGATIVE BUOYANCY RELATIVE TO AMBIENT BEYOND THIS POINT
              
      ! If the gap between interfaces is small, cycle:
      IF (deltaZ < (H*dzetalim/10.)) THEN !was (H*dzetalim/10.)
        i = i + 1
        CYCLE
      END IF
      has_deentrained = 1
      ndtran = ndtran + 1 ! Counting number of dentrainments
      
      deentrain_pos = (i+1) ! Position of detrainment
      zdtran(ndtran) = z(i+1) ! Height of detrainment
	
	! find the gprime of the new layer - calculated from the g' of the plume
	! as it reaches the top of the current layer ie using
	
	gprimea_new=gprimea(i+1)+xF(i+1)/xQ(i+1)

      ! If the gaussian routine under starting values has been enabled:
      IF (gaussian_on == 1) THEN
        !IF ((z(i+1) < .90) .AND. (z(i+1) < (jx-20))) THEN ! added 14.04.2007      
            CALL gaussian() ! Gaussian is the gaussian detrainment subroutine.
      END IF
      
	  !Add extra interface and move all interface values up one 
      
      CALL shift_layer() ! Renumber the layers from top of this layer and up  
	  jx = jx + 1 !increase no. of interfaces in enclosure   

	IF (j > 0) THEN 
	GO TO 1213
	END IF

		DO n_e = 1, jx+1
		WRITE(*,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
		END DO
 		  WRITE(*,*) '  now we have shifted the layers'
		WRITE(*,*) ' n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)'
  1213	CONTINUE

	 ! set only mom and F to zero at the interface at the bottom of the new layer  
	  gprimea(i+1)=gprimea_new
	  xF(i+1) = 0.
	 ! set vol., mom and F to zero at the interface at the top of the new layer  
	  xF(i+2) = 0.
	  xM(i+2) = 0.
	  xQ(i+2) = 0.
     
 	IF (j > 0) THEN 
	GO TO 1214
	END IF

		DO n_e = 1, jx+1
		WRITE(*,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
		END DO
		WRITE(*,*) ' n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)'
		WRITE(*,*) ' there is a layer detraining for i=',i
		WRITE(*,*) ' now the new layer has been inserted and allocated a gprime and volume'
		WRITE(*,*) ' j=',j,' jx=',jx,' i=',i
		PAUSE

247 FORMAT (1x,I3,1x,e13.6,1x,4(1x,e13.6))



 1214	CONTINUE


!$$$$$$       WRITE(*,*) ' Detrainment at', zdtran(ndtran)                                                                      
      !If there are too many interfaces being inserted, jump to next i   
      IF (ndtran > 3000) THEN
         WRITE(*,*) ' too many interfaces!'
!$$$$$$          WRITE(13,*)' too many interfaces being added!' 
!$$$$$$          WRITE(13,1103) j, time, ndtran, (zdtran(ixd), ixd=1,100)
!$$$$$$          1103 FORMAT(1x,I4,1x,e10.4,1x,I4,100(1x,e10.4))

      END IF
      
	! Need to step over the new layer
	i = i + 2

   END DO
  
END SUBROUTINE i_loop
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

SUBROUTINE shift_layer()
! Subroutine that shifts the layers one position
 DO mmi=i+1,jx+1   
    mni = (jx+1)+(i+1)-mmi 
    z(mni+1) = z(mni) 
    xF(mni+1) = xF(mni) 
    xQ(mni+1) = xQ(mni) 
    xM(mni+1) = xM(mni) 
    Q_s(mni+1) = Q_s(mni) 
    F_s(mni+1) = F_s(mni) 
    gprimea(mni+1) = gprimea(mni)
 END DO
END SUBROUTINE shift_layer
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

SUBROUTINE check_thickness()
!Subroutine that checks the thickness of the numerical interface
!and removes it if it is thinner than a specified limit

mni = 1 !counters
imm = 2

 DO
    IF (((z(imm+1)-z(imm))<= (dzetalim/5.)) .AND. (jx >= 3))  THEN  !was H*dzetalim/2., jx 10                                  
      
      ! Removes a layer
      DO mni=imm+1,jx+1
        z(mni)=z(mni+1) 
        xF(mni)=xF(mni+1) 
        xQ(mni)=xQ(mni+1) 
        xM(mni)=xM(mni+1) 
        Q_s(mni)=Q_s(mni+1) 
        F_s(mni)=F_s(mni+1) 
        gprimea(mni)=gprimea(mni+1)
      END DO
      
      jx = jx-1 ! one layer removed
      !WRITE(*,*) ' One layer removed'

    END IF
      imm = imm + 1 ! set to 2 before s.r. call
      IF (imm >= (jx-1)) EXIT
        
 END DO
END SUBROUTINE check_thickness
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$    

SUBROUTINE  pressure_distribution()
IMPLICIT NONE
!The routine calculates the ambient pressure distribution by integration
!then it finds the membrane volume flux and buoyancy flux.
!NOTE - we need to calc the pressure at the mid-height of the layer (not 
!		currently implemented)

!WRITE(*,*) ' start of press dist'

p_e = 0.
g_e(1) = 0.

! Numerical integration of the density distribution
! (finding the buoyancy in the box)

IF (pd_layers ==1) THEN

!If this is the first time step

	n_e=1
	p_e = rho_inf * 9.81 * H/2
	p_s = p0 + rho_s  * 9.81 * H/2
	Q_s(n_e) = c * (p_s - p_e)
	F_s(n_e) = Q_s(n_e) * 9.81*(rho_s-rho_inf)/rho_inf

!	write(*,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),Q_s(n_e),F_s(n_e)'
!	WRITE(*,242) n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),Q_s(n_e),F_s(n_e)


!STOP

ELSE

! For other than the first time step
!write(*,*) ' pd_layers, n_e, g_e(n_e),gprimea(n_e),z(n_e),z(n_e+1)'

DO n_e = 2, (pd_layers-2)
  
    g_e(n_e+1) = g_e(n_e) + gprimea(n_e)*(z(n_e+1) - z(n_e))

	
!	write(*,241) pd_layers, n_e, g_e(n_e),gprimea(n_e),z(n_e),z(n_e+1)
!241 FORMAT (1x,2(I3),1x,4(1x,e10.3))

END DO

! Now add the top layer to the integral
    g_e(pd_layers) = g_e(pd_layers-1) + gprimea(pd_layers-1)*(H - z(pd_layers))


DO n_e = 1, (pd_layers)

	IF (n_e == pd_layers) THEN
		p_e = rho_inf * (g_e(n_e) +9.81 * (z(n_e)+H)/2)
		p_s = p0 + rho_s * 9.81 * (z(n_e)+H)/2
		Q_s(n_e) = c * (p_s - p_e)
		F_s(n_e) = Q_s(n_e) * 9.81 * (rho_s/rho_inf-1-gprimea(n_e)/9.81)
	ELSE
		p_e = rho_inf * (g_e(n_e) +9.81 * (z(n_e)+z(n_e+1))/2)
		p_s = p0 + rho_s * 9.81 * (z(n_e)+z(n_e+1))/2
		Q_s(n_e) = c * (p_s - p_e)
		F_s(n_e) = Q_s(n_e) * 9.81 * (rho_s/rho_inf-1-gprimea(n_e)/9.81)

	END IF

END DO


	GO TO 1216
		WRITE(*,*) ' pressure_distribution subroutine, j=',j,' jx=',jx
		WRITE(*,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),Q_s(n_e),F_s(n_e)'
		DO n_e = 1, (pd_layers)
		WRITE(*,242) n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),Q_s(n_e),F_s(n_e)
		END DO
		242 FORMAT (1x,I3,2(1x,e11.6),1x,4(1x,e10.3))
		PAUSE
 1216	CONTINUE

END IF

!IF (jx == 2) STOP

END SUBROUTINE pressure_distribution
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

SUBROUTINE euler(z0, xQ0, xM0, z_euler, xQ, xM, alpha, xF, xFprime)
IMPLICIT NONE               
!Simple Euler method to solve DE's for                          
!plume volume flow, xq, and momentum,                           
!xm (xf = buoyancy flux).                                                      
REAL, INTENT(IN) :: z0, xQ0, xM0, z_euler, xF, alpha
REAL, INTENT(INOUT) :: xFprime
REAL, INTENT(OUT) :: xQ, xM 
!internal variables:
REAL :: h_step, xn, xkt, zn
REAL :: xQn, xFn, xMn, xQnew, xMnew,xxii
INTEGER :: ii

xn = 50. !xn = number of steps 
 
! Setting the local variables
zn = z0     !height of layer
xQn = xQ0   !volume flux into layer
xMn = xM0   !momentum flux into layer
xkt = 4. !4 ! non-linear mesh exponent (distribution of steps)
!h=(z-z0)/xn !distance per step (linear version)
  
!LOOP INCREMENTING Z

DO ii = 1, xn
    xxii=ii
	! Setting the next z
    zn = z0 + (z_euler-z0)*(xxii/xn)**xkt
    
    ! calc the distance of this step
    h_step = zn - (z0 + (z_euler-z0)*((xxii-1.)/xn)**xkt)
                                     
    IF (xMn < (1.e-12)) THEN
        xMn=1.e-12 
    END IF
    IF (xQn < (1.e-12)) THEN
        xQn=1.e-12 
    END IF
    !new buoyancy flux = old + source
        xFn = xF + xFprime*zn
    IF (varying_buoyancy == 0) THEN
        xQnew = xQn + alpha*xMn/(xQn)*h_step 

   ELSE IF (varying_buoyancy == 1) THEN
		! Use this next one if modelling fluid input from porous wall
        xQnew = xQn + alpha*xMn/(xQn)*h_step + Q_s(i)*h_step
        
    END IF      
    
    !new momentum flux = old + new
    xMnew = xMn + (xQn)*(xFn)/xMn*h_step
                                                  
    zn = zn + h_step
    xQn = xQnew
    xMn = xMnew

END DO

xQ=xQn !update volume flux
xM=xMn !update momentum flux
  
END SUBROUTINE euler


SUBROUTINE interface_check()
! Check if any of the interfaces has a height larger than H,
! and if so, remove them from z, F, Q, M, U and g' ambient

test = 0 !flag
  
DO jj =1, jx +1
    !WRITE(*,*) z(jj), U(jj)
    IF (z(jj) > H) THEN ! H is height of box 
      !WRITE(*,*) 'some interfaces swept out of top of box'     
      jHcount = jHcount + 1
      
      ! One or more interfaces have been swept out of the top of        
      ! box as a result of the plume de-entraining                      
      ! thus these interfaces and plume segments will be erased         
      ! and the maximum no. of segments reduced accordingly

      ! Remove the interfaces that are above the box

	GO TO 1217
		WRITE(*,*) 
		WRITE(*,*) ' interfaces being swept out of box, jx =',jx,' i=',i
			WRITE(*,*) ' n_e,  z(n_e),       gprimea(n_e),     xQ(n_e),     xF(n_e),     F_s(n_e)'
 			DO n_e = 1, jx+1
			WRITE(*,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
			END DO
			WRITE(*,*) ' jx=',jx,' time',time,' i=',jij,' z(i)=',z(jij)

	  Pause 
 1217	CONTINUE


      DO ijk = jj , jx + 1
        z(ijk) = 0.0
        xF(ijk) = 0.0 
        xQ(ijk) = 0.0 
        xM(ijk) = 0.0 
        U(ijk) = 0.0 
        gprimea(ijk) = 0.0 
	  END DO
      jx = jj - 1 ! number of layers reduced
      test = 1 ! to go to 99 after return
      
	GO TO 1218	  
			
		WRITE(*,*) 
		WRITE(*,*) ' interfaces being swept out of box, jx =',jx,' i=',i
			WRITE(*,*) ' now the layer has been removed, jx =',jx
			WRITE(*,*) ' n_e,  z(n_e),       gprimea(n_e),     xQ(n_e),     xF(n_e),     F_s(n_e)'
 			DO n_e = 1, jx+1
			WRITE(*,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
			END DO
  247 FORMAT (1x,I3,1x,e13.8,1x,4(1x,e11.4))

 1218	CONTINUE

   GO TO 2222
 

    ELSEIF (z(jj) < H) THEN                          
      ! Check that interfaces have not crossed position                   
      IF (jj == 1) CYCLE
      ELSE IF ((z(jj)-z(jj-1)) < .0) THEN
		WRITE(*,*) 
		WRITE(*,*) ' Two of the interfaces appear to have crossed '
		WRITE(*,*) ' jx=',jx,' i=',jj,' z(i)=',z(jj),' z(i-1)',z(jj-1)
		PAUSE
 !     z(jj) = z(jj-1) + 1.e-10
      jCross = jCross + 1
    END IF
                                                        
END DO

 2222  CONTINUE

IF (test /= 1) THEN !see flag behaviour
   jx = jx + 1
	ELSE
		GO TO 1219
  			 WRITE(7,*) 
			WRITE(7,*) ' this is now the end of subroutine interface_check, jx =',jx
			WRITE(7,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),Q_s(n_e),F_s(n_e)'
			WRITE(*,*) 
			WRITE(*,*) ' this is now the end of subroutine interface_check, jx =',jx

			DO n_e = 1, jx+1
			WRITE(*,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
			WRITE(7,247) n_e,z(n_e),gprimea(n_e),xQ(n_e),xF(n_e),F_s(n_e)
			END DO
			WRITE(*,*) ' jx=',jx,' time',time,' i=',jij,' z(i)=',z(jij)
			Pause
	 1219	CONTINUE
END IF

z(jx+1) = H

! Check that none of the interfaces has a zero z() value
 	DO jij=2,jx+1
		IF (z(jij) == 0.) Then
			WRITE(*,*) 
			WRITE(*,*) ' One of the z(jj) values is zero'
			WRITE(*,*) ' jx=',jx,' time',time,' i=',jij,' z(i)=',z(jij)
			pause
		END IF
	END DO 

END SUBROUTINE interface_check
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

SUBROUTINE ambient_stratification

INTEGER :: amb_layer, tot_amb_layers
REAL, ALLOCATABLE :: rho(:), g_prime_ambient(:), z_local(:)
REAL :: drho_inf, rho_gradient

REAL :: height, step_size

! The purpose of this subroutine is to create a stratified environment
! for the ambient. This is to 'test' DISTRAN
! for response on intrusion

tot_amb_layers = 200


ALLOCATE(rho(tot_amb_layers), g_prime_ambient(tot_amb_layers), z_local(tot_amb_layers))

drho_inf = rho_b - rho_t
rho_gradient = drho_inf / H

z_local(1) = 0.
z(1)=0.
z(tot_amb_layers+1)=H
rho(1) = rho_t

!gprimea(2) =  gprimea(1) - g * (rho(1) - rho_inf) / rho_inf

step_size = H / tot_amb_layers

amb_layer = 2

 DO amb_layer = 2,tot_amb_layers
!DO height = (0+step_size), H, step_size

  z_local(amb_layer) = z_local(amb_layer-1) + step_size
  z(amb_layer) = z(amb_layer-1) + step_size
  rho(amb_layer) = rho(amb_layer-1) + rho_gradient * step_size
  gprimea(amb_layer) = g * (rho(amb_layer) - rho_t) / rho_t
  
!  amb_layer = amb_layer + 1

END DO

	GO TO 1310
		WRITE(*,*) ' tot_amb_layers,amb_layer,z(amb_layer),z(amb_layer+1),gprimea(amb_layer)'
		DO amb_layer = 1,tot_amb_layers
		WRITE(*,244) tot_amb_layers,amb_layer,z(amb_layer),z(amb_layer+1),gprimea(amb_layer)
		END DO
		244 FORMAT (1x,2(I3),1x,3(1x,e10.3))
  1310	CONTINUE

jx = tot_amb_layers


END SUBROUTINE ambient_stratification
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
SUBROUTINE umax_find
! Finds velocity of fastest moving interface
Umax = 0
DO jj=1,jx+1
  U(jj)=(xQvent(j) - xQ(jj))*xL/S
  UU=abs(U(jj))
  IF (UU < Umax) CYCLE
  Umax=UU
END DO
! Umax is now the max velocity
END SUBROUTINE umax_find
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

SUBROUTINE gprimea_calc
! Calculates g' for the new ambient layer
        
      IF (abs(xQ(jx+1)) < 1.e-10) THEN !was xQ(jx+1), 1.e-10
        ! to prevent dividing by a very small number
        WRITE(*,*) ' xQ(j+1) < 1.e-10 probably because there is detrainment just below top layer '
		WRITE(*,*) ' jx=',jx,' gprimea(jx)=',gprimea(jx),' gprimea(jx+1)=',gprimea(jx+1) 
		WRITE(*,*) ' gprimea(jx+1) = gprimea(jx) '
                gprimea(jx+1) = gprimea(jx)
!		PAUSE
      ELSE     
           gprimea(jx+1) = gprimea(jx) + (xF(jx) + xFprime*(z(jx+1)-z(jx)))/xQ(jx+1)
 
      END IF

	IF (gprimea(jx+1) < gprimea(jx)) THEN
		GO TO 444
		WRITE(*,*) ' the new layer at top of box has a gprime less than that below',i
		WRITE(*,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)'
		DO n_e = 1, jx+1
		WRITE(*,247) n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)
		END DO
		WRITE(*,*) ' the new layer at top of box has a gprime less than that below',i
		WRITE(*,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)'
		PAUSE
 444	CONTINUE
 
 		gprimea(jx+1) = gprimea(jx)

END IF

!Calc buoyancy driven flow through vent:
IF (Astar /= 0.) THEN
 xintgz = 0.0 
 DO jj = 1,jx 
    IF (gprimea(jj)*(z(jj+1)-z(jj)) < 0) THEN 
	  WRITE(*,*) ' gprimea, xintgz negative, j=',j
	  WRITE(*,*) ' jx=',jx,' i=',jj,' gprimea=',gprimea(jj),' z(i)',z(jj),' z(i+1)',z(jj+1)
	  PAUSE
	  END IF
   xintgz = xintgz + gprimea(jj)*(z(jj+1)-z(jj))
 END DO
 
 !Note that xQvent is vent flow per unit length of source
	IF (xintgz < 0 ) THEN
		WRITE (*,*) ' xintgz is negative - sqrt problem'
		pause
		WRITE(*,*) ' xintgz =',xintgz,' jx=',jx,' i=',i
		WRITE(*,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)'
		DO n_e = 1, jx+1
		WRITE(*,247) n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)
		END DO
		PAUSE
247		FORMAT (1x,I3,2(1x,e11.6),1x,4(1x,e11.3))
	END IF

 xQvent(j) = Astar*sqrt(xintgz)/xL
 
 GOTO 2300
   WRITE(*,*) '   '
  WRITE(*,*) 'End of subrout gprimea_calc '
  WRITE(*,*) ' j=',j,' xQvent(j)=', xQvent(j)
  pause

 2300 CONTINUE


END IF

 GO TO 2121
   		WRITE (*,*) ' jx=',jx,' i=',i
		WRITE(*,*) ' n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)'
		DO n_e = 1, jx+1
		WRITE(*,247) n_e,z(n_e),z(n_e+1),gprimea(n_e),g_e(n_e),F_s(n_e),xF(n_e)
		END DO
		PAUSE
  2121	CONTINUE
     
END SUBROUTINE gprimea_calc
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$

SUBROUTINE gaussian
IMPLICIT NONE

! It is given a position of deentrainment. Then it finds the width
! of the deentrainment region based upon a Gaussian distribution,
! reduces the layers in the plume according to the distribution
! and increases the layers of the ambient, respectively.
! The mass transfer is equal to the thickness of the deentraining layer

REAL, ALLOCATABLE :: temp_amb(:), ambient(:)
INTEGER :: ig, deentrain, layers
REAL :: Area, b, v_deent, shift_height, C_nb, Q_nb, B_nb

! A box is divided into layers. Each layer 
! contains a certain amount of fluid.

! There is a plume inside the box. Some of the
! fluid from the plume side will enter the ambient.
! This is called detrainment.

layers = jx
! (i+1) is the (array) position of deentrainment
deentrain = deentrain_pos
 
ALLOCATE(temp_amb(layers), ambient(layers))

ambient = 0

! Constants of the plume equations:
C_nb = 1.
Q_nb = xQ(deentrain)
B_nb = 0.1

WRITE(*,*) 'GAUSSIAN!!!!'

DO ig = 1, jx-1
	ambient(ig) = z(ig) ! z contains the heights of all the layers   
END DO

temp_amb = ambient ! copy of ambient, used in calculations

shift_height = 0.00 ! SQRT(2*3.14159265*b)/(xL*S)

! b is the range of the intrusion
b = B_nb * (4/3) * alpha * ambient(deentrain) !ambient(deentrain) = z_nb
!$$$$$$ IF (b == 0.) THEN
!$$$$$$   b = 0.01
!$$$$$$ END IF
! If the plume is negatively bouyant it should de-entrain at that point.

CALL umax_find()
umax_nogo = 1

!CALL gaussian_area(0., ambient(jx-1), Area, b, ambient(deentrain), v_deent)
!z(deentrain) = z(deentrain) + xQ(deentrain)/(xL*S)
!z(deentrain) = z(deentrain) + b*SQRT(2*3.14159)/(xL*S)
!z(deentrain) = (z(deentrain)+z(deentrain+1))/2  

IF (b > 0.) THEN
  DO ig = 1, jx-1
    
    CALL gaussian_area(0., ambient(ig), Area, b, ambient(deentrain), v_deent)
    
    U(ig) = alpha * U(ig) - C_nb*Q_nb/(SQRT(2*3.14159*b))*v_deent
    
    xQ(ig) = xQ(ig) - C_nb*Q_nb*area
  
  END DO
END IF

DO ig = deentrain, jx - 1
    z(ig) = z(ig) + shift_height    
END DO  

DEALLOCATE(temp_amb, ambient)

END SUBROUTINE gaussian
      
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

SUBROUTINE matrices()
! This routine sets up matrices for printing.
! Each value needs two points in order to be plotted correctly,
! and the following loop creates arrays that satisfy this.

 INTEGER :: iii2
  DO iii=1,jx
      
    iii2=2*iii 
    zpr(iii2-1)=z(iii)
    
    IF (iii /= jx) THEN 
      zpr(iii2)=z(iii+1) 
    ELSE 
      zpr(iii2)=z(iii) 
    END IF 
                                                                    
    xQpr(iii2-1)=xQ(iii) 
    xQpr(iii2)=xQ(iii)
    
    Upr(iii2-1)=U(iii) 
    Upr(iii2)=U(iii)
    
    xFpr(iii2-1)=xF(iii) 
    xFpr(iii2)=xF(iii)
    
    gpr(iii2-1)=gprimea(iii) 
    gpr(iii2)=gprimea(iii)
    
    xMpr(iii2-1) = xM(iii) 
    xMpr(iii2) = xM(iii)
    
    
  END DO 
END SUBROUTINE matrices
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
SUBROUTINE menu_choice

choice: DO
  	WRITE(*,'(1X, A)') ' ================================='
    WRITE(*,'(1X, A)') ' '
    WRITE(*,'(1X, A)') ' Make a selection:'
    WRITE(*,'(1X, A)') ' '
    WRITE(*,100)
    100 FORMAT(1X, T4, ' [1] Start calculation', /, &
                & T4, ' [9] End')
    WRITE(*,'(1X, A)') ' '
    WRITE(*,150)
    150 FORMAT(1X, T4, '(Simulation will be carried out at Astar = )')
    DO i = 1, iAstmax
    	WRITE(*, 200) Ast(i)
		200 FORMAT(1X, T4, 10F6.4)
    END DO

    READ(*,*, IOSTAT = ierror) valg
    
    IF (ierror /= 0) THEN
      WRITE(*,50) ierror
      50 FORMAT(1X, ' You entered a wrong choice. Error no.', I3)
    ELSE
        SELECT CASE(valg)
            CASE(1)
            	EXIT choice
            CASE(9) ! End the program
            	STOP
			CASE DEFAULT
            	WRITE(*,*) ' Please change your input'
                CYCLE                
        END SELECT
    END IF

END DO choice

END SUBROUTINE menu_choice
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
SUBROUTINE openfiles
!Subroutine that opens relevant files for data storage
                
 !OPEN(unit=7,file='xQtran.res',status='REPLACE') !status was =new
 OPEN(unit=7,file='All.res',status='REPLACE')
 OPEN(unit=8,file='Utran.res',status='REPLACE') 
 OPEN(unit=9,file='Ftran.res',status='REPLACE') 
 OPEN(unit=10,file='ztran.res',status='REPLACE') 
 OPEN(unit=11,file='distran.dat',status='REPLACE') 
 !OPEN(unit=12,file='comment.dat',status='new')                  
 OPEN(unit=13,file='zdtran.res',status='REPLACE') 
 
END SUBROUTINE openfiles
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
SUBROUTINE write_results
! Writes the contents of the arrays created
! in subroutine matrices to the file 'all.res'

tau = time * alpha**(2./3.)*(H*xFprime)**(1./3.)*xL/S
WRITE(*,*) time
WRITE(7,*) ''
WRITE(7,*) ' j ', 'jx ', 'time ','tau', ' dzetalim0', ' Ast',' Ast_non_dim'
WRITE(7,363) j, jx, time,tau, dzetalim0, Ast,Ast_non_dim
363 FORMAT(1X, I7, 1X, I7, 5(1X, e8.3))


WRITE(7,*) ' z ', 'xQ   ', 'xF   ', 'U   ', 'g   ', 'xM ', 'b ', 'Q_s ', 'F_s '

DO jj = 1, jx+1

  WRITE(7,365) z(jj) , xQ(jj), xF(jj), U(jj), gprimea(jj), xM(jj), b_array(jj), Q_s(jj), F_s(jj)
!$$$$$$   WRITE(*,365) z(jj) , xQ(jj), xF(jj), U(jj), gprimea(jj), xM(jj), b_array(jj)
END DO
  
  365 FORMAT(1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4)
  
WRITE(7,*) '  '
WRITE(7,*) 'j ',' time',' xQvent '
WRITE(7,*) ' this is per unit width of source'
DO jj= 1, j
WRITE(7,366)jj,xtime(jj),xQvent(jj)
END DO
  366	 FORMAT(1x,I6,2(1x, e10.4))

END SUBROUTINE write_results
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$       


SUBROUTINE writefiles()

  !write(7,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
  !write(7,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
  !write(7,*)' Astar=', Astar,' AreaS=',S 
  write(7,*)'  ' 
                                                                   
!$$$$$$   write(8,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
!$$$$$$   write(8,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
!$$$$$$   write(8,*)' Astar=', Astar,' AreaS=',S 
!$$$$$$   write(8,*)'  ' 
!$$$$$$                                                                    
!$$$$$$   write(9,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
!$$$$$$   write(9,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
!$$$$$$   write(9,*)' Astar=', Astar,' AreaS=',S 
!$$$$$$   write(9,*)'  ' 
!$$$$$$                                                                    
!$$$$$$   write(10,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
!$$$$$$   write(10,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
!$$$$$$   write(10,*)' Astar=', Astar,' AreaS=',S 
!$$$$$$   write(10,*)'  ' 
!$$$$$$   write(10,*)' j,jx,time,z(i)' 
!$$$$$$   write(13,*)'j,time,ndtran,(zdtran(ixd),ixd=1,100)'

END SUBROUTINE writefiles
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
END MODULE shared_var