	MODULE shared_var
!This module includes all the global variables
	IMPLICIT NONE
	SAVE

	REAL, DIMENSION(30000) :: zpr, xQpr, gpr, Upr, zdtran, ldtran, xFpr, xMpr
	REAL, DIMENSION(30002) :: z,U, xM, xQ, gprimea, xfirst, xF,xQvent,xtime, b_array
	REAL, DIMENSION(1) :: Prtime
	REAL, DIMENSION(1) :: Ast ! 14

	!INTEGER :: iPrmax
	REAL :: iPrmax, dzetalim, alpha, astarh, s, astar, deltat
	REAL :: xfprime, v0, xxQ0, xL, deltaZ, time
	REAL :: starHL, xF0, xM0, xQ0, gprime0, qmLs,gprimea_new
	INTEGER :: iAst, umax_nogo
	REAL :: H, xintgz, Umax, UU, z0, gap
	INTEGER :: j, imm, jx, i, iPrcount, iii, iyy !counters
	INTEGER :: jj, N, iAstmax, ii, ixd, mni, mmi, ijk 				  !counters
	INTEGER :: test, valg, iError
	INTEGER :: jHcount, jCross, ndtran 
	INTEGER :: ilk, jdtran ! counters for the de-entrainment
	INTEGER :: typestar ! printout counter
	INTEGER :: stratified_on, deentrain_pos, gaussian_on, has_deentrained, gprime_avg

	CONTAINS
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE init_var()
!This subroutine initializes the variables
	z = 0 		! height
	 z0 = 0 	! virtual origin
	 zpr = 0 	! z'
	zdtran = 0 !
	ldtran = 0 !
	U = 0		!
	Upr = 0	!
	gpr = 0	!
	gprimea = 0 ! g' ambient
	iPrcount = 0 ! print counter
	iAst=0    	! start iAst at 0 to get all the values in Ast(i)                  
	xfirst = 0	!
	xtime = 0	!
	 xQ = 0		!
	 xQvent = 0 !vent flow per unit length of source 
	 xF = 0		!
	xM = 0		!
	b_array = 0.

	END SUBROUTINE init_var
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE start_values
!This subroutine gives the starting values and specifies
!timestep, A*, and at what time to write results.

! Prtime is an array containing the times at which we are 
! going to print out data

!Prtime = (/.1,.2,.5,1.1,4.,7.5,11.8,20.6,30.,40.8/)
	Prtime = (/100.0/)
!Prtime = (/3./)

	iPrmax = SIZE(Prtime) ! The number of times the simulation will print
	umax_nogo = 0
 
!Ast is an array containing values of A* at which we want to     
! carry out the simulation.
	Ast = 0.00001
!Ast = (/.0468, 0.0939, 1.2/)     
!Ast = (/0.0,.003,.004,.006,.01,.015,.02,.04, .06,.08,.1,.2,.4,.6/)

	iAstmax= SIZE(Ast) !The number of A* values to simulate

	dzetalim = 0.003 ! dzetalim is the max non-dimensional distance                     
                 ! an interface can move between time steps
                
	stratified_on = 0 ! if = 1, the inital ambient is stratified, 
				  ! not uniform (needs some debugging)
	gaussian_on = 0 ! if = 1, the detrainment routine will use 
				! a gaussian profile for the intrusion

!$$$$$$     gprime_avg = 1 !if = 1, average gprime for the new layer after detrainment
!Source flow conditions:
	v0 = 0        !source velocity in [m/s]
!rhosource = 0 !density [kg/m^3]), !is this one used?
	gprimea(1) = 0 !initial g' in box

!READ(11,*)qmLs,xL,H,S,gprime0,Astar,N
!@@ read from file OR use data below:
	qmLs=1.e6   !qmLs - flow in [mL/s],
	xL=1.       !source horiz Length [m]
	H=1.        !height of box
	S=1.        ![m^2] = Horiz cross sectional area of box
	gprime0 = 3.231E-01  ! g' in [m^4s^-3],
	Astar=1.    ! A* effective vent area
	N=500       ! N = no. of timestep
 !@@
	xxQ0 = qmLs/1.e6 	!total source vol. flow in m^3/s 
	v0 = xxQ0/(H*xL) 	!source velocity [m/s]
	has_deentrained = 0 ! control variable

 !********************                                                   
 !     NOTE: xQ, xQvent, xF and xM are all per unit horiz length of source              
 !********************
      
	xQ0 = 0.0 ! Source volume, momentum and buoyancy flux are all zero
	xM0 = 0.0 ! at the leading edge of the distributed source.
	xF0 = 0.0 !

	xFprime = gprime0 * xxQ0 / (H*xL) !source buoyancy flux/unit area
	z0=0.0
	gprimea(1) = 0

!$$$$$$ alpha=0.1*sqrt(2.0)                                            
	alpha=1.0 ! entrainment coefficient

	END SUBROUTINE start_values
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$  
	SUBROUTINE i_loop()
	DO
      ! i = 1 at first run
	  deltaZ = z(i+1)-z(i)
      CALL euler (z0,xQ(i),xM(i),deltaZ,xQ(i+1),xM(i+1),alpha,xF(i),xFprime)
      
      IF (i >= (jx)) EXIT ! exit i-loop if position = no. of layers
                              
!     Calc new new ambient layer
        
      xF(i+1) = xF(i) + xFprime * deltaZ -xQ(i+1)*(gprimea(i+1)-gprimea(i))    !new buoyancy flux w.r.t. local ambient
 													! was xQ(i+1)

      b_array(i) = 0.1*(4/3)* alpha * z(i) ! array containing the width of the plume

      ! SHOULD NOT ONLY BE NEGATIVELY BOUYANT, BUT ALSO HAVE ZERO VELOCITY

	  IF (j <= 10) THEN !To early for detrainment
		i = i + 1      
		CYCLE
	  END IF
      
	  ! Check though the layers if any have the possibility of detraining
      IF (xF(i+1) >= 0.) THEN ! if not negative buoyancy: CYCLE      
        i = i + 1
        CYCLE
      END IF
      
      ! *******************************************************************
	  ! xF(i+1) HAS NEGATIVE BUOYANCY RELATIVE TO AMBIENT BEYOND THIS POINT
 
                  
      ! If the gap between interfaces is small, cycle:
      IF (deltaZ < (H*dzetalim/10)) THEN
        i = i + 1
        CYCLE
      END IF
      
      has_deentrained = 1
      ndtran = ndtran + 1 ! Counting number of dentrainments
      
      deentrain_pos = (i+1) ! Position of detrainment
      zdtran(ndtran) = z(i+1) ! Height of detrainment

	! find the gprime of the new layer (calculated from the g' of the plume
	! as it reaches the top of the current layer (note that xF(i+1) will be < 0
	
	gprimea_new=gprimea(i+1)+xF(i+1)/xQ(i+1)
	!write(*,*) ' de-entrainment, z(i), gprime(i),gprime_new,gprime(i+1)'
	!write(*,*)z(i),gprimea(i), gprimea_new, gprimea(i+1)

      ! If the gaussian routine under starting values has been enabled:
      IF (gaussian_on == 1) THEN
        !IF ((z(i+1) < .90) .AND. (z(i+1) < (jx-20))) THEN ! added 14.04.2007      
            CALL gaussian() ! Gaussian is the gaussian detrainment subroutine.
      END IF
      
      !Add extra interface and move all interface values up one 
      
      CALL shift_layer() ! Shift layers from bottom and up  
	  
	 ! set vol., mom and F to zero at the interface at the top on the new layer  
	  xF(i+2) = 0.
	  xM(i+2) = 0.
	  xQ(i+2) = 0.
        
	  jx = jx + 1 !increase no. of interfaces in enclosure   

!$$$$$$       WRITE(*,*) ' Detrainment at', zdtran(ndtran)                                                                      
      !If there are too many interfaces being inserted, jump to next i   
      IF (ndtran > 3000) THEN
         WRITE(*,*) ' too many interfaces!'
         WRITE(13,*)' too many interfaces being added!' 
         WRITE(13,1103) j, time, ndtran, (zdtran(ixd), ixd=1,100)
1103	FORMAT(1x,I4,1x,e10.4,1x,I4,100(1x,e10.4))
      END IF
      
	! Need to step over the new layer
      i = i + 2

	END DO
	END SUBROUTINE i_loop
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE shift_layer()
! Subroutine that shifts the layers one position
	DO mmi=i+1,jx+1   
	mni = (jx+1)+(i+1)-mmi 
	z(mni+1) = z(mni) 
	xF(mni+1) = xF(mni) 
	xQ(mni+1) = xQ(mni) 
	xM(mni+1) = xM(mni) 
	gprimea(mni+1) = gprimea(mni)
	END DO
	END SUBROUTINE shift_layer
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE check_thickness()
!Subroutine that checks the thickness of the numerical interface
!and removes it if it is thinner than a specified limit

	mni = 1 !counters
	imm = 2

	DO
	IF (((z(imm+1)-z(imm))<= (H*dzetalim/2.)) .AND. (jx >= 10))  THEN  !was H*dzetalim/2.                                  
      
      ! Removes a layer
      DO mni=imm+1,jx+1
        z(mni)=z(mni+1) 
        xF(mni)=xF(mni+1) 
        xQ(mni)=xQ(mni+1) 
        xM(mni)=xM(mni+1) 
        gprimea(mni)=gprimea(mni+1)
      END DO
      
      jx = jx-1 ! one layer removed
      !WRITE(*,*) ' One layer removed'

	END IF
      imm = imm + 1 ! set to 2 before s.r. call
      IF (imm >= (jx-1)) EXIT
        
	END DO
	END SUBROUTINE check_thickness
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$        
	SUBROUTINE interface_check()
! Check if any of the interfaces has a height larger than H,
! and if so, remove them from z, F, Q, M, U and g' ambient

	test = 0 !flag
  
	DO jj =1, jx +1
    !WRITE(*,*) z(jj), U(jj)
	IF (z(jj) >= H) THEN ! H is height of box 
      !WRITE(*,*) 'some interfaces swept out of top of box'     
      jHcount = jHcount + 1
      
      ! One or more interfaces have been swept out of the top of        
      ! box as a result of the plume de-entraining                      
      ! thus these interfaces and plume segments will be erased         
      ! and the maximum no. of segments reduced accordingly
                   
      !write(10,*)'some interfaces swept out of top of box'          
      !write(10,1100)j,jx,time,(z(ii),ii=1,N) 

      ! Remove the interfaces that are above the box
      DO ijk = jj , jx + 1
        z(ijk) = 0.0
        xF(ijk) = 0.0 
        xQ(ijk) = 0.0 
        xM(ijk) = 0.0 
        U(ijk) = 0.0 
        gprimea(ijk) = 0.0 
	  END DO
      jx = jj - 1 ! number of layers reduced
      test = 1 ! to go to 99 after return
      EXIT
	ELSEIF (z(jj) < H) THEN                          
      ! Check that interfaces have not crossed position                   
      IF (jj == 1) CYCLE
      IF ((z(jj)-z(jj-1)) > H*1.e-8) CYCLE
      z(jj) = z(jj-1) + 1.e-8
      jCross = jCross + 1
	END IF                                                          
	END DO

	IF (test /= 1) THEN !see flag behaviour
	jx = jx + 1
	END IF
 
        z(jx+1) = H
!$$$$$$         z(jx+1) = H
        
	END SUBROUTINE interface_check
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE ambient_stratification

	INTEGER :: amb_layer, tot_amb_layers
	REAL, ALLOCATABLE :: z(:), rho(:), g_prime_ambient(:)
	REAL :: H, rho_top, rho_bottom
	REAL :: drho_inf, rho_w, g, rho_gradient

	REAL :: height, step_size

! The purpose of this subroutine is to create a stratified environment
! for the ambient. This is to 'test' DISTRAN
! for response on intrusion

! Total height is H = 1 dim. less, or H = .410
! h = g' / N**2
! N**2 = -g/rho * d(rhoinf)/d(z)
! Buoyancy frequency (a temp. grad of 3 C/m = 0.3Hz)

! DATA from Hough's exp. 80
!$$$$$$ tot_amb_layers = jx ! jx is no. of layers in DISTRAN
	tot_amb_layers = 100

	g = 9.81
	!g_pr_a = g * (rho_inf - rho) / rho
	rho_w = 999
	rho_bottom = 1096.6
	rho_top = 1031.7
!dz = .410
!H = 0.41
	H = 1

	ALLOCATE(z(tot_amb_layers), rho(tot_amb_layers),g_prime_ambient(tot_amb_layers))

	tot_amb_layers = SIZE(z) - 1

	drho_inf = rho_bottom - rho_top
	rho_gradient = - drho_inf / H

	z(1) = 0
	rho(1) = rho_bottom
	g_prime_ambient(1) =  - g * (rho_w - rho(1)) / rho(1)

	step_size = H / tot_amb_layers

	amb_layer = 2

	DO height = (0+step_size), H, step_size

	z(amb_layer) = height
	rho(amb_layer) = rho(1) + rho_gradient * height
	g_prime_ambient(amb_layer) = - g * (rho_w - rho(amb_layer))/rho(amb_layer)
  ! note: this shouldn't be negative... but g' needs to be positive? 
  
	amb_layer = amb_layer + 1

  
	END DO

	WRITE(*,*) '    z', '                density', '        g''   '
	WRITE(*,*) '    ', '                '
	DO amb_layer = tot_amb_layers+1, 1, -1
	WRITE(*,*) z(amb_layer), rho(amb_layer), g_prime_ambient(amb_layer)
	END DO

	jx = tot_amb_layers

	DO amb_layer = 1, tot_amb_layers+1
	    gprimea(amb_layer) = g_prime_ambient(amb_layer)
	xF(amb_layer) = g_prime_ambient(amb_layer)

	END DO

	END SUBROUTINE ambient_stratification
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE umax_find
! Finds velocity of fastest moving interface
	Umax = 0
	DO jj=1,jx+1
	U(jj)=(xQvent(j) - xQ(jj))*xL/S
	UU=abs(U(jj))
	IF (UU < Umax) CYCLE
	Umax=UU
	END DO
! Umax is now the max velocity
	END SUBROUTINE umax_find
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE gprimea_calc
! Calculates g' for the new ambient layer
        
!$$$$$$  IF (stratified_on == 1) THEN ! added this 22.03.2007, last IF-test is the original
!$$$$$$       IF (abs(xQ(jx+1)) >= 1.e-10) THEN
!$$$$$$         ! to prevent dividing by a very small number
!$$$$$$         gprimea(jx+1)= gprimea(jx+1) + gprimea(jx)+ (xF(jx) + xFprime*(z(jx+1)-z(jx)))/xQ(jx+1)
!$$$$$$       ELSE
!$$$$$$         gprimea(jx+1) = gprimea(jx+1) + gprimea(jx) ! added this 22.03.2007
!$$$$$$       END IF
!$$$$$$  ELSE

      IF (abs(xQ(jx+1)) < 1.e-10) THEN !was xQ(jx+1), 1.e-10
        ! to prevent dividing by a very small number
        WRITE(*,*) 'NOT GOOD'
        gprimea(jx+1) = gprimea(jx)
      ELSE     
        gprimea(jx+1) = gprimea(jx) + (xF(jx) + xFprime*(z(jx+1)-z(jx)))/xQ(jx+1)   !was xQ(jx+1)   
      END IF

      !i = i+1
      
!$$$$$$  END IF

	xintgz = 0.0 !buoyancy driven flow through vent
!Calc buoyancy driven flow through vent:
	DO jj = 1,jx 
	xintgz = xintgz + gprimea(jj)*(z(jj+1)-z(jj))
	END DO
 
!Note that xQvent is vent flow per unit length of source
	xQvent(j) = Astar*sqrt(xintgz)/xL
	WRITE(*,*) 'xQvent(j)=', xQvent(j), 'First front=', z(2) ! added May 29
! write(10,*)xQvent(j)
        
	END SUBROUTINE gprimea_calc
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$

	SUBROUTINE gaussian
	IMPLICIT NONE

! It is given a position of deentrainment. Then it finds the width
! of the deentrainment region based upon a Gaussian distribution,
! reduces the layers in the plume according to the distribution
! and increases the layers of the ambient, respectively.
! The mass transfer is equal to the thickness of the deentraining layer
! O-J Myrtroeen 2007-20-03, myrtroen@gmail.com.
! rewritten 2007-26-04

	REAL, ALLOCATABLE :: temp_amb(:), ambient(:)
	INTEGER :: ig, deentrain, layers
	REAL :: Area, b, v_deent, shift_height, C_nb, Q_nb, B_nb

! A box is divided into layers. Each layer 
! contains a certain amount of fluid.

! There is a plume inside the box. Some of the
! fluid from the plume side will enter the ambient.
! This is called detrainment.

	layers = jx
! (i+1) is the (array) position of deentrainment
	deentrain = deentrain_pos
 
	ALLOCATE(temp_amb(layers), ambient(layers))

	ambient = 0

! Constants of the plume equations:
	C_nb = 1.
	Q_nb = xQ(deentrain)
	B_nb = 0.1

	DO ig = 1, jx-1
	ambient(ig) = z(ig) ! z contains the heights of all the layers   
	END DO

	temp_amb = ambient ! copy of ambient, used in calculations

	shift_height = 0.00 ! SQRT(2*3.14159265*b)/(xL*S)

! b is the range of the intrusion
	b = B_nb * (4/3) * alpha * ambient(deentrain) !ambient(deentrain) = z_nb
!$$$$$$ IF (b == 0.) THEN
!$$$$$$   b = 0.01
!$$$$$$ END IF
! If the plume is negatively bouyant it should de-entrain at that point.

! DETRAINMENT ITERATION, DRAINS THE ENTRAINMENT LAYER

!CALL gprimea_calc()
! Find the velocities
	CALL umax_find()
	umax_nogo = 1

!CALL gaussian_area(0., ambient(jx-1), Area, b, ambient(deentrain), v_deent)
!z(deentrain) = z(deentrain) + xQ(deentrain)/(xL*S)
!z(deentrain) = z(deentrain) + b*SQRT(2*3.14159)/(xL*S)
!z(deentrain) = (z(deentrain)+z(deentrain+1))/2  

	IF (b > 0.) THEN
	DO ig = 1, jx-1
    
	CALL gaussian_area(0.,ambient(ig),Area,b,ambient(deentrain),v_deent)
    
    !U(ig) = alpha * U(ig) - (4/3)*C_nb*Q_nb/(alpha*z(deentrain))*v_deent
	U(ig) = alpha * U(ig) - C_nb*Q_nb/(SQRT(2*3.14159*b))*v_deent
    
    !U(ig) = U(ig)*(1-v_deent)
    !U(ig) = alpha * U(ig) - (0.004/dzetalim)*xQ(deentrain)/(alpha*z(deentrain))*v_deent
    
	xQ(ig) = xQ(ig) - C_nb*Q_nb*area
    
    !xQ(ig) = xQ(ig) - (0.004/dzetalim)*ABS(xQ(ig)*area)
    !xQ(ig) = xQ(ig)*(1-area)
  
	END DO
	END IF

!$$$$$$ xF(i + 2) = 0.
!$$$$$$ xM(i + 2) = 0.
!$$$$$$ xQ(i+2) =0.

	DO ig = deentrain, jx - 1
	z(ig) = z(ig) + shift_height    
	END DO  

	DEALLOCATE(temp_amb, ambient)

	END SUBROUTINE gaussian
      
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 

	SUBROUTINE matrices()
! This routine sets up matrices for printing.
! Each value needs two points in order to be plotted correctly,
! and the following loop creates arrays that satisfy this.

	INTEGER :: iii2
	DO iii=1,jx
      
	iii2=2*iii 
	zpr(iii2-1)=z(iii)
    
	IF (iii /= jx) THEN 
      zpr(iii2)=z(iii+1) 
	ELSE 
      zpr(iii2)=z(iii) 
	END IF 
                                                                    
	xQpr(iii2-1)=xQ(iii) 
	xQpr(iii2)=xQ(iii)
    
	Upr(iii2-1)=U(iii) 
	Upr(iii2)=U(iii)
    
	xFpr(iii2-1)=xF(iii) 
	xFpr(iii2)=xF(iii)
    
	gpr(iii2-1)=gprimea(iii) 
	gpr(iii2)=gprimea(iii)
    
	xMpr(iii2-1) = xM(iii) 
	xMpr(iii2) = xM(iii)
	
    
	END DO 
	END SUBROUTINE matrices
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	SUBROUTINE menu_choice

	choice: DO
  	WRITE(*,'(1X, A)') ' ================================='
	WRITE(*,'(1X, A)') ' '
	WRITE(*,'(1X, A)') ' Make a selection:'
	WRITE(*,'(1X, A)') ' '
	WRITE(*,100)
 100	FORMAT(1X, T4, ' [1] Start calculation', /, T4, ' [9] End')
	WRITE(*,'(1X, A)') ' '
	WRITE(*,150)
150	FORMAT(1X, T4, '(Simulation will be carried out at Astar = )')
	DO i = 1, iAstmax
    	WRITE(*, 200) Ast(i)
200	FORMAT(1X, T4, 10F6.4)
	END DO
	READ(*,*, IOSTAT = ierror) valg
    
	IF (ierror /= 0) THEN
      WRITE(*,50) ierror
50	FORMAT(1X, ' You entered a wrong choice. Error no.', I3)
	ELSE
        SELECT CASE(valg)
            CASE(1)
            	EXIT choice
            CASE(9) ! End the program
            	STOP
			CASE DEFAULT
            	WRITE(*,*) ' Please change your input'
                CYCLE                
        END SELECT
	END IF

	END DO choice

	END SUBROUTINE menu_choice
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
	SUBROUTINE openfiles
!Subroutine that opens relevant files for data storage
                
 !OPEN(unit=7,file='xQtran.res',status='REPLACE') !status was =new
	OPEN(unit=7,file='All.res',status='REPLACE')
	OPEN(unit=8,file='Utran.res',status='REPLACE') 
	OPEN(unit=9,file='Ftran.res',status='REPLACE') 
	OPEN(unit=10,file='ztran.res',status='REPLACE') 
	OPEN(unit=11,file='distran.dat',status='old') 
 !OPEN(unit=12,file='comment.dat',status='new')                  
	OPEN(unit=13,file='zdtran.res',status='REPLACE') 
 
	END SUBROUTINE openfiles
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$
	SUBROUTINE write_results
! Writes the contents of the arrays created
! in subroutine matrices to the file 'all.res'

	WRITE(*,*) time
	WRITE(7,*) ''
	WRITE(7,*) ' j ', 'jx ', 'time '
	WRITE(7,363) j, jx, time
363	FORMAT(1X, I4, 1X, I4, 1X, e10.4)
	WRITE(7,*) ' z ', 'xQ   ', 'xF   ', 'U   ', 'g   ', 'xM ', 'b '

!$$$$$$ DO jj = 1, jx*2
!$$$$$$ 
!$$$$$$   WRITE(7,365) zpr(jj) , xQpr(jj), xFpr(jj), Upr(jj), gpr(jj), xMpr(jj)
!$$$$$$   WRITE(*,365) zpr(jj) , xQpr(jj), xFpr(jj), Upr(jj), gpr(jj), xMpr(jj)
!$$$$$$   
!$$$$$$   365 FORMAT(1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4)
!$$$$$$   
!$$$$$$ END DO

	DO jj = 1, jx

	WRITE(7,365) z(jj) , xQ(jj), xF(jj), U(jj), gprimea(jj),xM(jj), b_array(jj) 
!$$$$$$   WRITE(*,365) z(jj) , xQ(jj), xF(jj), U(jj), gprimea(jj), xM(jj), b_array(jj)
  
365	FORMAT(1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4, 1x, e10.4)
  
	END DO

	END SUBROUTINE write_results
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$       
	SUBROUTINE writefiles()

	write(7,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
	write(7,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
	write(7,*)' Astar=', Astar,' AreaS=',S 
	write(7,*)' A*/H**2=',AstarH,' alpha=',alpha 
	write(7,*)' A*/(H*L)=',starHL,' dzetlim=',dzetalim 
	write(7,*)'  ' 
                                                                   
	write(8,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
	write(8,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
	write(8,*)' Astar=', Astar,' AreaS=',S 
	write(8,*)' A*/H**2=',AstarH,' alpha=',alpha 
	write(8,*)' A*/(H*L)=',starHL,' dzetlim=',dzetalim 
	write(8,*)'  ' 
                                                                   
	write(9,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
	write(9,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
	write(9,*)' Astar=', Astar,' AreaS=',S 
	write(9,*)' A*/H**2=',AstarH,' alpha=',alpha 
	write(9,*)' A*/(H*L)=',starHL,' dzetlim=',dzetalim 
	write(9,*)'  ' 
                                                                   
	write(10,*)' gprime0=',gprime0,' L=',xL,' xxQ0=',xxQ0 
	write(10,*)'  H=',H,' v0=',v0,' xFprime',xFprime 
	write(10,*)' Astar=', Astar,' AreaS=',S 
	write(10,*)' A*/H**2=',AstarH,' alpha=',alpha 
	write(10,*)' A*/(H*L)=',starHL,' dzetlim=',dzetalim 
	write(10,*)'  ' 
	write(10,*)' j,jx,time,z(i)' 
	write(13,*)'j,time,ndtran,(zdtran(ixd),ixd=1,100)'

	END SUBROUTINE writefiles
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ !$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$!$$$$$$ 
	END MODULE shared_var